##########################################################################
# divides peaks into specific classes by residue type
def collect_peaks_byclass(resList):


	names = ['Ala', 'Methyl', 'UB Chi 1', 'Ring', 'UB Chi 2', \
			'Chi 3', 'Chi 4'] 
	peaks_byclass = []
	for x in names:
		peaks_byclass.append([x,[],[]])

	for res in resList:
	        name = '%s_%s' %(res.pdbCode, res.fullName)
	        if res.name == 'ALA':
	        	peaks_byclass[0][2].append(name)
	        	peaks_byclass[0][1].append(res.peakList[0].peak1)
	        	peaks_byclass[1][2].append(name)
	        	peaks_byclass[1][1].append(res.peakList[0].peak1)
	        if res.name in ['ILE', 'LEU', 'THR']:
	        	peaks_byclass[1][2].append(name)
	        	peaks_byclass[1][1].append(res.peakList[0].peak3)
	        	peaks_byclass[1][1].append(res.peakList[0].peak4)
	        if res.name == 'VAL':
	        	peaks_byclass[1][2].append(name)
	        	peaks_byclass[1][1].append(res.peakList[0].peak2)
	        	peaks_byclass[1][1].append(res.peakList[0].peak3)
	        if res.chi1 and res.name != 'ALA':
	        	peaks_byclass[2][2].append(name)
	        	peaks_byclass[2][1].append(res.peakList[0].peak1)
	        if res.ring:
	        	peaks_byclass[3][2].append(name)
	        	peaks_byclass[3][1].append(res.peakList[0].peak1)
	        if res.chi2 and res.name != 'VAL':
	        	peaks_byclass[4][2].append(name)
	        	peaks_byclass[4][1].append(res.peakList[0].peak2)
	        if res.chi3 and not res.methyl:
	        	peaks_byclass[5][2].append(name)
	        	peaks_byclass[5][1].append(res.peakList[0].peak3)
	        if res.chi4 and not res.methyl:
	        	peaks_byclass[6][2].append(name)
	        	peaks_byclass[6][1].append(res.peakList[0].peak4)
	return peaks_byclass

##########################################################################
# write out statistics for totals from run
def write_tot_stats(parms, resLength, peaks_byclass):
	
	parms.outfile.write("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n")
	parms.outfile.write("Collecting statistics...\n\n")
	
	#print out total counts
	parms.outfile.write("   ..................Total Counts.................\n")
	parms.outfile.write("   Final number used in analysis\n\n")
	
	parms.outfile.write("      Total Sampled Side chains = %s\n" %resLength)
	
	nameList = []
	for p in peaks_byclass:
		if p[0] in ['UB Chi 1', 'Ring', 'UB Chi 2', 'Chi 3', 'Chi 4']:
			nameList.extend(p[2])
	nameList = list(set(nameList))
	parms.outfile.write("      Side Chains Sampled for Alt Confs = %s\n" \
					%len(nameList))
	
	for i, p in enumerate(peaks_byclass):
		parms.outfile.write("      %s side chains = %s\n" %(p[0], len(p[1])))  
	parms.outfile.write("\n")



