# Ringer default macros, rules and targets for test Makefiles.

SHELL = /bin/sh

# This is the default target.
all: test

rapid.end:  rapid.end.end

ringer: chiSample atomSampleType ringDefaults peakPicking mapScaling multiConf chi2chi1 verboseOut createRingerPlot

rapid.end.end: 
	$(RINGER)/end.rapid/END.RAPID -i end.in -o end.out
	
	
chiSample:
	# test changing chi angle sampling
	$(RINGER)/ringer/ringer -i chiSample.in -o chiSample.out
	../dif -t 3 chiSample.out.save chiSample.out
	../dif -t 3 chiSample.ala_peaklist.txt.save chiSample.ala_peaklist.txt
	../dif -t 3 chiSample.ubchi1_peaklist.txt.save chiSample.ubchi1_peaklist.txt
	../dif -t 3 chiSample.ubchi2_peaklist.txt.save chiSample.ubchi2_peaklist.txt
	../dif -t 3 chiSample.chi3_peaklist.txt.save chiSample.chi3_peaklist.txt
	../dif -t 3 chiSample.chi4_peaklist.txt.save chiSample.chi4_peaklist.txt
	../dif -t 3 chiSample.signal_plot.txt.save chiSample.signal_plot.txt
	
atomSampleType:
	#test changing method of calculating bond length and angle for sampling
	$(RINGER)/ringer/ringer -i atomSampleType1.in -o atomSampleType1.out
	$(RINGER)/ringer/ringer -i atomSampleType2.in -o atomSampleType2.out
	$(RINGER)/ringer/ringer -i atomSampleType3.in -o atomSampleType3.out
	../dif -t 3 atomSampleType1.out.save atomSampleType1.out
	../dif -t 3 atomSampleType1.ala_peaklist.txt.save atomSampleType1.ala_peaklist.txt
	../dif -t 3 atomSampleType1.ubchi1_peaklist.txt.save atomSampleType1.ubchi1_peaklist.txt
	../dif -t 3 atomSampleType1.ubchi2_peaklist.txt.save atomSampleType1.ubchi2_peaklist.txt
	../dif -t 3 atomSampleType1.chi3_peaklist.txt.save atomSampleType1.chi3_peaklist.txt
	../dif -t 3 atomSampleType1.chi4_peaklist.txt.save atomSampleType1.chi4_peaklist.txt
	../dif -t 3 atomSampleType2.out.save atomSampleType2.out
	../dif -t 3 atomSampleType2.ala_peaklist.txt.save atomSampleType2.ala_peaklist.txt
	../dif -t 3 atomSampleType2.ubchi1_peaklist.txt.save atomSampleType2.ubchi1_peaklist.txt
	../dif -t 3 atomSampleType2.ubchi2_peaklist.txt.save atomSampleType2.ubchi2_peaklist.txt
	../dif -t 3 atomSampleType2.chi3_peaklist.txt.save atomSampleType2.chi3_peaklist.txt
	../dif -t 3 atomSampleType2.chi4_peaklist.txt.save atomSampleType2.chi4_peaklist.txt
	../dif -t 3 atomSampleType3.out.save atomSampleType3.out
	../dif -t 3 atomSampleType3.ala_peaklist.txt.save atomSampleType3.ala_peaklist.txt
	../dif -t 3 atomSampleType3.ubchi1_peaklist.txt.save atomSampleType3.ubchi1_peaklist.txt
	../dif -t 3 atomSampleType3.ubchi2_peaklist.txt.save atomSampleType3.ubchi2_peaklist.txt
	../dif -t 3 atomSampleType3.chi3_peaklist.txt.save atomSampleType3.chi3_peaklist.txt
	../dif -t 3 atomSampleType3.chi4_peaklist.txt.save atomSampleType3.chi4_peaklist.txt
	
ringDefaults:
	# test ringer defaults
	$(RINGER)/ringer/ringer -i default.in
	../dif -t 3 ringer.out.save ringer.out
	
peakPicking:
	# Test hard lower signal cutoff
	$(RINGER)/ringer/ringer -i lCut.in -o lCut.out
	../dif -t 3 lCut.out.save lCut.out
	# Test hard upper signal cutoff
	$(RINGER)/ringer/ringer -i uCut.in -o uCut.out
	../dif -t 3 uCut.out.save uCut.out

mapScaling:
	# Test scaling electron density maps
	$(RINGER)/ringer/ringer -i mapScaling.in -o mapScaling.out
	../dif -t 3 mapScaling.out.save mapScaling.out
	
multiConf:
	# Test skipping multiple conformers
	$(RINGER)/ringer/ringer -i mConf.in -o mConf.out
	../dif -t 3 mConf.out.save mConf.out
	
chi2chi1:
	# Test identifying peaks of the chi2 atom sampling
	# built from chi1
	$(RINGER)/ringer/ringer -i chi2chi1.in -o chi2chi1.out
	../dif -t 3 chi2chi1.out.save chi2chi1.out
	../dif -t 3 chi2chi1.chi2chi1_peaklist.txt.save chi2chi1.chi2chi1_peaklist.txt

verboseOut:
	# Test verbose output
	$(RINGER)/ringer/ringer -i vOut.in -o vOut.out
	../dif -t 3 vOut.out.save vOut.out
	../dif -t 3 vOut.ala_peaklist.txt.save vOut.ala_peaklist.txt
	../dif -t 3 vOut.ubchi1_peaklist.txt.save vOut.ubchi1_peaklist.txt
	../dif -t 3 vOut.ubchi2_peaklist.txt.save vOut.ubchi2_peaklist.txt
	../dif -t 3 vOut.chi3_peaklist.txt.save vOut.chi3_peaklist.txt
	../dif -t 3 vOut.chi4_peaklist.txt.save vOut.chi4_peaklist.txt
	../dif -t 3 vOut.signal_plot.txt.save vOut.signal_plot.txt

createRingerPlot:
	# Test analysis of Ringer plot	
	$(RINGER)/ringer/create_ringer_plot --residue=LYS_A_29_chi1 --input_prefix=../verboseOut/vOut
	../dif -t 3 LYS_A_29_chi1_ring.txt.save LYS_A_29_chi1_ring.txt
	$(RINGER)/ringer/create_ringer_plot --residue=LYS_A_29_chi1 --input_prefix=../verboseOut/vOut \
		--haveMatPlotLib
	
	
# Find and emit the dif files.
check:
	@(find . -name "*.dif" ! -size 0c -print | \
	while read dif ;\
	do \
	    echo $$dif ;\
	    cat $$dif ;\
	    echo ;\
	done ;\
	echo 'Check complete!')

clean_ringer:
	/bin/rm -f *.dif *.out *_plot.txt *peaklist.txt *ring.txt

clean_rapid.end.end:
	/bin/rm -f RAPID_END.log 2FoFc_END.map
		
# This special target declares these targets as phony, ie, not based on
# files with that name; it avoids problems when such files do exist.
.PHONY:  all check test\
	 clean \
	 create_ringer_plot
	 chiSample \
	 ringDefaults \
	 peakPicking \
	 multiConf \
	 chi2chi1 \
	 verboseOut \
	 ringer clean_ringer
	

